## ocaml-pprint 20220103

=== Makefile ===
# ------------------------------------------------------------------------------

# The version number is automatically set to the current date,
# unless DATE is defined on the command line.
DATE     := $(shell /bin/date +%Y%m%d)

# The project's name.
THIS     := pprint

# The archive's URL (https).
ARCHIVE  := https://github.com/fpottier/$(THIS)/archive/$(DATE).tar.gz

# ------------------------------------------------------------------------------

.PHONY: all
all:
	@ dune build @all

.PHONY: clean
clean:
	@ git clean -fX

.PHONY: test
test:
	@ dune runtest --force

.PHONY: bench
bench:
	@ dune build ./bench/PPrintBench.exe
	@ time dune exec ./bench/PPrintBench.exe

.PHONY: install
install: all
	@ dune install -p $(THIS)

.PHONY: uninstall
uninstall:
	@ ocamlfind remove $(THIS) || true

.PHONY: reinstall
reinstall: uninstall
	@ make install

.PHONY: show
show: reinstall
	@ echo "#require \"pprint\";;\n#show PPrint;;" | ocaml

.PHONY: pin
pin:
	@ opam pin add $(THIS) . --yes

.PHONY: unpin
unpin:
	@ opam pin remove $(THIS) --yes

# ------------------------------------------------------------------------------

# Documentation.

DOCDIR = _build/default/_doc/_html
DOC    = $(DOCDIR)/index.html

.PHONY: doc
doc:
	@ rm -rf _build/default/_doc
	@ dune clean
	@ dune build @doc
	@ echo "You can view the documentation by typing 'make view'".

.PHONY: view
view: doc
	@ echo Attempting to open $(DOC)...
	@ if command -v firefox > /dev/null ; then \
	  firefox $(DOC) ; \
	else \
	  open -a /Applications/Firefox.app/ $(DOC) ; \
	fi

.PHONY: export
export: doc
	ssh yquem.inria.fr rm -rf public_html/$(THIS)/doc
	scp -r $(DOCDIR) yquem.inria.fr:public_html/$(THIS)/doc

# ------------------------------------------------------------------------------

# [make versions] compiles the package under many versions of OCaml,
# whose list is specified below.

# This requires appropriate opam switches to exist. A missing switch
# can be created like this:
#   opam switch create 4.03.0

VERSIONS := \
  4.02.3 \
  4.03.0 \
  4.04.2 \
  4.05.0 \
  4.06.1 \
  4.07.1 \
  4.08.1 \
  4.09.1 \
  4.09.0+bytecode-only \
  4.10.0 \
  4.11.1 \
  4.12.0 \
  4.13.0 \

.PHONY: versions
versions:
	@(echo "(lang dune 2.0)" && \
	  for v in $(VERSIONS) ; do \
	    echo "(context (opam (switch $$v)))" ; \
	  done) > dune-workspace.versions
	@ dune build --workspace dune-workspace.versions

# ------------------------------------------------------------------------------

# [make headache] updates the headers.

HEADACHE := headache
HEADER   := header

.PHONY: headache
headache:
	@ for f in src/*.{ml,mli} bench/*.{ml,mli} ; do \
	  $(HEADACHE) -h $(HEADER) $$f ; \
	done

# -------------------------------------------------------------------------

# Publishing a release.

.PHONY: release
release:
# Make sure the current version can be compiled and installed.
	@ make uninstall
	@ make clean
	@ make install
# Check the current package description.
	@ opam lint
# Check if everything has been committed.
	@ if [ -n "$$(git status --porcelain)" ] ; then \
	    echo "Error: there remain uncommitted changes." ; \
	    git status ; \
	    exit 1 ; \
	  else \
	    echo "Now making a release..." ; \
	  fi
# Create a git tag.
	@ git tag -a $(DATE) -m "Release $(DATE)."
# Upload. (This automatically makes a .tar.gz archive available on gitlab.)
	@ git push
	@ git push --tags
# Done.
	@ echo "Done."
	@ echo "If happy, please type:"
	@ echo "  \"make publish\"   to publish a new opam package"
	@ echo "  \"make export\"    to upload the documentation to yquem.inria.fr"

.PHONY: publish
publish:
# Publish an opam description.
	@ opam publish -v $(DATE) $(THIS) $(ARCHIVE) .

.PHONY: undo
undo:
# Undo the last release (assuming it was done on the same date).
	@ git tag -d $(DATE)
	@ git push -u origin :$(DATE)

# -------------------------------------------------------------------------

# Copying pprint into Menhir's working directory.

MENHIR_WORKING_COPY=$(HOME)/dev/menhir
PPRINT_COPY=$(MENHIR_WORKING_COPY)/pprint

.PHONY: menhir
menhir: clean
# Copy our source files to the Menhir repository.
	@ rm -rf $(PPRINT_COPY)
	@ cp -r $(shell pwd) $(PPRINT_COPY)
# Remove a number of unneeded files and subdirectories.
	@ (cd $(PPRINT_COPY) && rm -rf .git .gitignore Makefile README.md TODO.md bench blog header test src/Makefile)

=== debian/changelog ===
ocaml-pprint (20220103-1) unstable; urgency=medium

  * Initial release. (Closes: #1014118)

 -- Julien Puydt <jpuydt@debian.org>  Thu, 30 Jun 2022 17:45:29 +0200

=== debian/control ===
Source: ocaml-pprint
Section: ocaml
Priority: optional
Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
Uploaders: Julien Puydt <jpuydt@debian.org>
Build-Depends: debhelper-compat (= 13),
               dh-ocaml,
               dune,
               ocaml-findlib,
               ocaml-nox
Standards-Version: 4.6.1
Rules-Requires-Root: no
Homepage: https://github.com/fpottier/pprint
Vcs-Git: https://salsa.debian.org/ocaml-team/ocaml-pprint.git
Vcs-Browser: https://salsa.debian.org/ocaml-team/ocaml-pprint

Package: libpprint-ocaml
Architecture: any
Depends: ${misc:Depends}, ${ocaml:Depends}
Suggests: ocaml-findlib
Provides: ${ocaml:Provides}
Description: Pretty printing toolbox for OCaml (runtime files)
 OCaml library for pretty-printing textual documents. It takes
 care of indentation and line breaks, and is typically used
 on code.
 .
 This package contains the runtime files to use the library.

Package: libpprint-ocaml-dev
Architecture: any
Depends: ${misc:Depends}, ${ocaml:Depends}
Suggests: ocaml-findlib
Provides: ${ocaml:Provides}
Description: Pretty printing toolbox for OCaml (dev files)
 OCaml library for pretty-printing textual documents. It takes
 care of indentation and line breaks, and is typically used
 on code.
 .
 This package contains the development files for the library.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/ocaml/ocamlvars.mk

%:
	dh $@ --with ocaml

override_dh_auto_clean:
	# upstream uses git...

override_dh_auto_build:
	dune build

override_dh_auto_install:
	dune install --destdir=$(CURDIR)/debian/tmp --prefix=/usr --libdir=..$(OCAML_STDLIB_DIR)
	# drop excess LICENSE files
	find debian/tmp -name "LICENSE*" -delete
	# we detect what to ship
	find debian/tmp -regextype posix-awk \
	  -regex '.*\.(cma|cmxs)$$' \
	  >> debian/libpprint-ocaml.install
	find debian/tmp -regextype posix-awk \
	  -regex '.*\.(a|cmi|cmo|cmt|cmti|cmx|cmxa|ml|mli|o])$$' \
	  >> debian/libpprint-ocaml-dev.install

## ocaml-pprint 20230830

=== Makefile ===
--- 
+++ 
@@ -18,16 +18,16 @@
 
 .PHONY: clean
 clean:
-	@ git clean -fX
+	@ git clean -fdX
 
 .PHONY: test
 test:
-	@ dune runtest --force
+	@ dune exec test/PPrintTest.exe
 
 .PHONY: bench
 bench:
-	@ dune build ./bench/PPrintBench.exe
-	@ time dune exec ./bench/PPrintBench.exe
+	@ make -C benchmark_old $@
+	@ make -C benchmark_new $@
 
 .PHONY: install
 install: all
@@ -91,7 +91,6 @@
 #   opam switch create 4.03.0
 
 VERSIONS := \
-  4.02.3 \
   4.03.0 \
   4.04.2 \
   4.05.0 \
@@ -104,6 +103,8 @@
   4.11.1 \
   4.12.0 \
   4.13.0 \
+  4.14.1 \
+  5.0.0 \
 
 .PHONY: versions
 versions:
@@ -122,7 +123,7 @@
 
 .PHONY: headache
 headache:
-	@ for f in src/*.{ml,mli} bench/*.{ml,mli} ; do \
+	@ for f in {src,benchmark_old}/*.{ml,mli} benchmark_new/*.ml ; do \
 	  $(HEADACHE) -h $(HEADER) $$f ; \
 	done
 
@@ -175,10 +176,23 @@
 MENHIR_WORKING_COPY=$(HOME)/dev/menhir
 PPRINT_COPY=$(MENHIR_WORKING_COPY)/pprint
 
+UNNECESSARY= \
+  .git \
+  .gitignore \
+  Makefile \
+  README.md \
+  TODO.md \
+  benchmark_old \
+  benchmark_new \
+  blog \
+  header \
+  test \
+  src/Makefile \
+
 .PHONY: menhir
 menhir: clean
 # Copy our source files to the Menhir repository.
 	@ rm -rf $(PPRINT_COPY)
 	@ cp -r $(shell pwd) $(PPRINT_COPY)
 # Remove a number of unneeded files and subdirectories.
-	@ (cd $(PPRINT_COPY) && rm -rf .git .gitignore Makefile README.md TODO.md bench blog header test src/Makefile)
+	@ (cd $(PPRINT_COPY) && rm -rf $(UNNECESSARY))

=== benchmark_new/Makefile ===
.PHONY: all
all:
	dune build @all

.PHONY: clean
clean:
	git clean -fX .

.PHONY: bench
bench:
	dune exec ./main.exe -- time alloc samples -quota 10

.PHONY: once
once:
	dune exec ./main.exe -- time alloc -quota 1x

=== benchmark_old/Makefile ===
.PHONY: all
all:
	dune build @all

.PHONY: clean
clean:
	git clean -fX .

.PHONY: bench
bench:
	dune exec ./PPrintBench.exe

=== blog/Makefile ===
# --------------------------------------------------------------------------------

# [make billet] creates the blog entry.

.PHONY: billet clean

billet: billet.html

clean:
	rm -f billet.html

%.html: %.markdown
	pandoc -s $< -c style.css > $@

=== debian/changelog ===
ocaml-pprint (20230830-1build4) questing; urgency=medium

  * Rebuild against new OCAML ABIs.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 16 Jun 2025 15:02:27 +0200

ocaml-pprint (20230830-1build3) plucky; urgency=medium

  * Rebuild against new OCAML ABI.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Wed, 29 Jan 2025 09:20:21 +0100

ocaml-pprint (20230830-1build2) oracular; urgency=medium

  * Rebuild against new OCAML ABIs.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Fri, 09 Aug 2024 14:16:13 +0200

ocaml-pprint (20230830-1build1) noble; urgency=medium

  * Rebuild against new OCAML ABI.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 02 Nov 2023 10:14:47 +0100

ocaml-pprint (20230830-1) unstable; urgency=medium

  * Team upload
  * New upstream release

 -- Stéphane Glondu <glondu@debian.org>  Fri, 08 Sep 2023 06:42:22 +0200

ocaml-pprint (20220103-3) unstable; urgency=medium

  * Team upload
  * Use ocaml_dune DH buildsystem

 -- Stéphane Glondu <glondu@debian.org>  Thu, 17 Aug 2023 07:56:32 +0200

ocaml-pprint (20220103-2) unstable; urgency=medium

  * Fix compilation with recent dune.
  * Bump standards-version to 4.6.2

 -- Julien Puydt <jpuydt@debian.org>  Thu, 06 Jul 2023 12:16:32 +0200

=== debian/watch ===
version=4
https://github.com/fpottier/pprint/tags .*/([\d\.]+).tar.gz
